create or replace
PROCEDURE CALCULAREST1
(
  RSP OUT VARCHAR2
)
IS
/******************************************************************************
   NOMBRE:      CALCULAREST1
   PROPSITO:   Calcula y genera la tabla EST1

   PARAMETERS:  rsp
   INPUT:       
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     CALCULAREST1(rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
contador      INTEGER;
idpar_        NUMBER;
nom_        	VARCHAR2 (200);
import_       NUMBER(10,2);
rsp2 VARCHAR2(200);
l_rc sys_refcursor;
BEGIN
	param_entrada:= '';
  
  delete from est1;
  
  OPEN l_rc FOR
	select h.idparlamento, p.nombre,sum(importe) as importe
  from
  (
    (select idparlamento,sum(importesiniva) as importe
    from historicogastoparlamento
    where to_char(fecha,'yyyyMM')>=to_char(add_months(sysdate,-48),'yyyyMM')
    group by idparlamento
    )
    union
    (
    select idparlamento,sum(importesiniva) as importe
    from historicogastoparlamentario
    where to_char(fecha,'yyyyMM')>=to_char(add_months(sysdate,-48),'yyyyMM')
    group by idparlamento
    )
  ) h , parlamento p
  where h.idparlamento=p.idparlamento  
  group by h.idparlamento, p.nombre;
  
  
  
	 LOOP
     FETCH l_rc INTO idpar_,nom_, import_;
     EXIT WHEN l_rc%NOTFOUND;
     ALTAEST1(idpar_, nom_, import_,rsp);     
   END LOOP;
   CLOSE l_rc;

   -- Fin de las operaciones
   rsp := 'OK';
  altalog ('CALCULAREST1',param_entrada,rsp,rsp2);
   COMMIT;
EXCEPTION
 WHEN OTHERS
   THEN
   ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

    altalog ('CALCULAREST1',param_entrada,rsp,rsp2);

END CALCULAREST1;
/