create or replace
PROCEDURE CALCULAREST2
(
  idParlamento_ IN EST2.idParlamento%TYPE, 
  anyo_ NUMBER,
  RSP OUT VARCHAR2
)
IS
/******************************************************************************
   NOMBRE:      CALCULAREST2
   PROPSITO:   Calcula y genera la tabla EST2

   PARAMETERS:  idParlamento_, anyo_,rsp
   INPUT:       idParlamento_, anyo_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     CALCULAREST2('1','2012',rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
contador      INTEGER;
nom_        	VARCHAR2 (200);
dif_          NUMBER(10,2);
rsp2 VARCHAR2(200);

BEGIN
	param_entrada:= '';
  
  begin  
    SELECT NOMBRE INTO nom_
    FROM PARLAMENTO
    WHERE IDPARLAMENTO=idparlamento_;
  
  DELETE FROM EST2 
  WHERE IDPARLAMENTO=idparlamento_
  AND anyo=anyo_;
  
  
  SELECT (MAX(TOTAL) - MIN(TOTAL)) INTO dif_
  FROM
  (
    SELECT IDPARLAMENTO, IDPARLAMENTARIO, SUM(IMPORTESINIVA) AS TOTAL
    FROM HISTORICOGASTOPARLAMENTARIO
    WHERE IDPARLAMENTO=idParlamento_
    AND TO_CHAR(FECHA,'YYYY')=anyo_
    GROUP BY IDPARLAMENTO, IDPARLAMENTARIO
  );
  
  
   -- Fin de las operaciones
   rsp := 'OK';
  ALTAEST2(idParlamento_, nom_, anyo_, dif_, rsp);   
  if (rsp='OK') then   
    altalog ('CALCULAREST2',param_entrada,rsp,rsp2);
    COMMIT;
  else
    ROLLBACK;
    altalog ('CALCULAREST2',param_entrada,rsp,rsp2);
  end if;
end;
EXCEPTION
 WHEN OTHERS
   THEN
   ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

    altalog ('CALCULAREST2',param_entrada,rsp,rsp2);
END CALCULAREST2;
/