create or replace
PROCEDURE CALCULAREST3
(
  anyo_ NUMBER,
  RSP OUT VARCHAR2
)
IS
/******************************************************************************
   NOMBRE:      CALCULAREST3
   PROPSITO:   Calcula y genera la tabla EST3

   PARAMETERS:  anyo_, rsp
   INPUT:       anyo_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     CALCULAREST3('2012',rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
contador      INTEGER;
idpar_        NUMBER;
nom_        	VARCHAR2 (200);
import_       NUMBER(10,2);
rsp2 VARCHAR2(200);

BEGIN
	param_entrada:= '';
    --Inicio una nueva transaccion
  begin
  DELETE FROM EST3 
  WHERE anyo=anyo_;
  

    SELECT IDPARLAMENTO, NOMBRE, IMPORTE into idpar_, nom_, import_
    FROM
    (
      SELECT H.IDPARLAMENTO, P.NOMBRE,SUM(IMPORTE) AS IMPORTE
      FROM
      (
        (SELECT IDPARLAMENTO,SUM(IMPORTESINIVA) AS IMPORTE
        FROM HISTORICOGASTOPARLAMENTO
        WHERE TO_CHAR(FECHA,'YYYY')=anyo_
        GROUP BY IDPARLAMENTO
        )
        UNION
        (
        SELECT IDPARLAMENTO,SUM(IMPORTESINIVA) AS IMPORTE
        FROM HISTORICOGASTOPARLAMENTARIO
        WHERE TO_CHAR(FECHA,'YYYY')=anyo_
        GROUP BY IDPARLAMENTO
        )
      ) H , PARLAMENTO P
      WHERE H.IDPARLAMENTO=P.IDPARLAMENTO  
      GROUP BY H.IDPARLAMENTO, P.NOMBRE
      ORDER BY 3 DESC
    )
    WHERE ROWNUM  <=1;
    rsp := 'OK';
    ALTAEST3(idpar_, nom_,anyo_, import_,rsp); 
  if (rsp='OK') then   
    altalog ('CALCULAREST3',param_entrada,rsp,rsp2);  
    COMMIT;
  else
    ROLLBACK;
     altalog ('CALCULAREST3',param_entrada,rsp,rsp2);  
  end if;
   -- Fin de las operaciones
  end; 
  
EXCEPTION
 WHEN OTHERS
   THEN
   ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

    altalog ('CALCULAREST3',param_entrada,rsp,rsp2);

END CALCULAREST3;
/