create or replace
PROCEDURE CALCULAREST4
(
  RSP OUT VARCHAR2
)
IS
/******************************************************************************
   NOMBRE:      CALCULAREST4
   PROPSITO:   Calcula y genera la tabla EST4

   PARAMETERS:  rsp
   INPUT:       
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     CALCULAREST4(rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
contador      INTEGER;
idpar_        NUMBER;
idrio_        NUMBER;
nom_        	VARCHAR2 (200);
import_       NUMBER(10,2);
rsp2 VARCHAR2(200);
l_rc sys_refcursor;
BEGIN
	param_entrada:= '';
  
  delete from est4;
  
  OPEN l_rc FOR
	select h.idparlamento,h.idparlamentario, p.nombreapellidos,sum(importe) as importe
  from
  (   
    select idparlamento, idparlamentario,sum(importesiniva) as importe
    from historicogastoparlamentario
    where to_char(fecha,'yyyyMM')>=to_char(add_months(sysdate,-48),'yyyyMM')
    group by idparlamento, idparlamentario
  ) h , parlamentario p
  where h.idparlamento=p.idparlamento  
  and h.idparlamentario=p.idparlamentario
  group by h.idparlamento,h.idparlamentario, p.nombreapellidos;
    
  
	 LOOP
     FETCH l_rc INTO idpar_,idrio_, nom_, import_;
     EXIT WHEN l_rc%NOTFOUND;     
     ALTAEST4(idpar_, idrio_, nom_, import_,rsp);
   END LOOP;
   CLOSE l_rc;

   -- Fin de las operaciones
   rsp := 'OK';
  altalog ('CALCULAREST4',param_entrada,rsp,rsp2);
   COMMIT;
EXCEPTION
 WHEN OTHERS
   THEN
   ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

    altalog ('CALCULAREST4',param_entrada,rsp,rsp2);

END CALCULAREST4;
/