create or replace
PROCEDURE CALCULAREST5
(
  anyo_ NUMBER,
  RSP OUT VARCHAR2
)
IS
/******************************************************************************
   NOMBRE:      CALCULAREST5
   PROPSITO:   Calcula y genera la tabla EST5

   PARAMETERS:  anyo_, rsp
   INPUT:       anyo_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     CALCULAREST5('2012',rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
contador      INTEGER;
import_       NUMBER(10,2);
rsp2 VARCHAR2(200);

BEGIN
	param_entrada:= '';
  begin
  DELETE FROM EST5 
  WHERE anyo=anyo_;
  

   	SELECT ROUND(AVG(IMPORTE),2) INTO import_
  FROM
  (   
    SELECT IDPARLAMENTO, IDPARLAMENTARIO,SUM(IMPORTESINIVA) AS IMPORTE
    FROM HISTORICOGASTOPARLAMENTARIO
    WHERE TO_CHAR(FECHA,'YYYY')=anyo_
    GROUP BY IDPARLAMENTO, IDPARLAMENTARIO
  );
  rsp := 'OK';
     ALTAEST5(anyo_, import_,rsp);
  if (rsp='OK') then   
    altalog ('CALCULAREST5',param_entrada,rsp,rsp2);
    COMMIT;
  else
    ROLLBACK;
    altalog ('CALCULAREST5',param_entrada,rsp,rsp2);
  end if;
   -- Fin de las operaciones    
   end;
EXCEPTION
 WHEN OTHERS
   THEN
   ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

    altalog ('CALCULAREST5',param_entrada,rsp,rsp2);

END CALCULAREST5;
/