create or replace
PROCEDURE CALCULAREST6
(
  anyo_ NUMBER,
  RSP OUT VARCHAR2
)
IS
/******************************************************************************
   NOMBRE:      CALCULAREST6
   PROPSITO:   Calcula y genera la tabla EST6

   PARAMETERS:  anyo_, rsp
   INPUT:       anyo_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     CALCULAREST6('2012',rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
contador      INTEGER;

importMax_       NUMBER(10,2);
importMin_       NUMBER(10,2);
idMax           NUMBER;
idMin           NUMBER;
idParlamMax     NUMBER;
idParlamMin     NUMBER;
nMax            VARCHAR(200);
nMin            VARCHAR(200);
i               NUMBER;

rsp2 VARCHAR2(200);

BEGIN
	param_entrada:= '';
  
  --Inicio una nueva transaccion
  begin
  DELETE 
  FROM EST6 
  WHERE anyo=anyo_;
    
  
    SELECT IDPARLAMENTO, IDPARLAMENTARIO,NOMBREAPELLIDOS, TOTAL INTO idParlamMax, idMax,nMax, importMax_
    FROM
    (
        SELECT P.IDPARLAMENTO, P.IDPARLAMENTARIO, P.NOMBREAPELLIDOS,SUM(H.IMPORTESINIVA) AS TOTAL
        FROM HISTORICOGASTOPARLAMENTARIO H, PARLAMENTARIO P
        WHERE TO_CHAR(H.FECHA,'YYYY')=anyo_
        AND P.IDPARLAMENTO=H.IDPARLAMENTO
        AND P.IDPARLAMENTARIO=H.IDPARLAMENTARIO
        GROUP BY P.IDPARLAMENTO, P.IDPARLAMENTARIO, P.NOMBREAPELLIDOS
        ORDER BY TOTAL DESC
    )
    WHERE ROWNUM<=1;
    
  
    SELECT IDPARLAMENTO, IDPARLAMENTARIO,NOMBREAPELLIDOS, TOTAL INTO idParlamMin, idMin, nMin, importMin_
    FROM
    (
        SELECT P.IDPARLAMENTO, P.IDPARLAMENTARIO, P.NOMBREAPELLIDOS,SUM(H.IMPORTESINIVA) AS TOTAL
        FROM HISTORICOGASTOPARLAMENTARIO H, PARLAMENTARIO P
        WHERE TO_CHAR(H.FECHA,'YYYY')=anyo_
        AND P.IDPARLAMENTO=H.IDPARLAMENTO
        AND P.IDPARLAMENTARIO=H.IDPARLAMENTARIO
        GROUP BY P.IDPARLAMENTO, P.IDPARLAMENTARIO, P.NOMBREAPELLIDOS
        ORDER BY TOTAL ASC
    )
    WHERE ROWNUM<=1;
    
  ALTAEST6(anyo_,idParlamMax,idMax,nMax,importMax_, idParlamMin,idMin,nMin,importMin_, rsp);
  if (rsp='OK') then   
    altalog ('CALCULAREST6',param_entrada,rsp,rsp2);
    COMMIT;
  else
    ROLLBACK;
    altalog ('CALCULAREST6',param_entrada,rsp,rsp2);
  end if;
  end;
EXCEPTION
 WHEN OTHERS
   THEN
   ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

    altalog ('CALCULAREST6',param_entrada,rsp,rsp2);

END CALCULAREST6;
/