create or replace
PROCEDURE CALCULAREST7
(
  anyo_ NUMBER,
  RSP OUT VARCHAR2
)
IS
/******************************************************************************
   NOMBRE:      CALCULAREST7
   PROPSITO:   Calcula y genera la tabla EST7

   PARAMETERS:  anyo_, rsp
   INPUT:       anyo_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     CALCULAREST7('2012',rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
contador      INTEGER;
nom_          VARCHAR2(200);
import_       NUMBER(10,2);
rsp2 VARCHAR2(200);

BEGIN
	param_entrada:= '';
  begin
  DELETE FROM EST7 
  WHERE anyo=anyo_;
  
  SELECT P.NOMBRE, PROMEDIO INTO nom_, import_
  FROM
  (
    SELECT IDPARLAMENTO, PROMEDIO
    FROM
    (
      SELECT IDPARLAMENTO, ROUND(AVG(IMPORTE),2) AS PROMEDIO
      FROM
      (   
        SELECT IDPARLAMENTO, IDPARLAMENTARIO,SUM(IMPORTESINIVA) AS IMPORTE
        FROM HISTORICOGASTOPARLAMENTARIO
        WHERE TO_CHAR(FECHA,'YYYY')=anyo_
        GROUP BY IDPARLAMENTO, IDPARLAMENTARIO
      )
      GROUP BY IDPARLAMENTO
      ORDER BY 2 DESC
    )
    WHERE ROWNUM <=1
  ) H, PARLAMENTO P
  WHERE H.IDPARLAMENTO=P.IDPARLAMENTO;
  rsp := 'OK';
  ALTAEST7(anyo_,nom_, import_,rsp);
  if (rsp='OK') then   
    altalog ('CALCULAREST7',param_entrada,rsp,rsp2);
    COMMIT;
  else
    ROLLBACK;
    altalog ('CALCULAREST7',param_entrada,rsp,rsp2);
  end if;
   -- Fin de las operaciones
   end;
EXCEPTION
 WHEN OTHERS
   THEN
   ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

    altalog ('CALCULAREST7',param_entrada,rsp,rsp2);
END CALCULAREST7;
/