create or replace
PROCEDURE CALCULAREST8
(
  anyo_ NUMBER,
  RSP OUT VARCHAR2
)
IS
/******************************************************************************
   NOMBRE:      CALCULAREST8
   PROPSITO:   Calcula y genera la tabla EST8

   PARAMETERS:  anyo_, rsp
   INPUT:       anyo_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     CALCULAREST8('2012',rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
contador      INTEGER;

import_       NUMBER(10,2);
rsp2 VARCHAR2(200);

BEGIN
	param_entrada:= '';
  begin
  DELETE FROM EST8 
  WHERE anyo=anyo_;
  
 	SELECT SUM(IMPORTE) INTO import_
  FROM
  (
    (SELECT NVL(SUM(IMPORTESINIVA),0) AS IMPORTE
    FROM HISTORICOGASTOPARLAMENTO
    WHERE TO_CHAR(FECHA,'YYYY')=anyo_
    )
    UNION
    (
    SELECT NVL(SUM(IMPORTESINIVA),0) AS IMPORTE
    FROM HISTORICOGASTOPARLAMENTARIO
    WHERE TO_CHAR(FECHA,'YYYY')=anyo_
    )
  );
  rsp := 'OK';
  ALTAEST8(anyo_, import_, rsp);
  
 if (rsp='OK') then   
    altalog ('CALCULAREST8',param_entrada,rsp,rsp2);
    COMMIT;
  else
    ROLLBACK;
   altalog ('CALCULAREST8',param_entrada,rsp,rsp2);
  end if;
end;

EXCEPTION
 WHEN OTHERS
   THEN
   ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

    altalog ('CALCULAREST8',param_entrada,rsp,rsp2);

END CALCULAREST8;
/