create or replace
PROCEDURE ALTAFORMAPAGOPARLAMENTARIO
(
 DESCRIPCION IN FORMAPAGO.descripcion%TYPE, 
 RSP OUT VARCHAR2  
)
IS
/******************************************************************************
   NOMBRE:      ALTAFORMAPAGOPARLAMENTARIO
   PROPSITO:   gestiona el alta de una forma de pago de un parlamentario

   PARAMETERS:  descripcion, rsp
   INPUT:       descripcion
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     altaFormaPagoParlamentario('Tarjeta VISA', rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
rsp2 VARCHAR2(200);
idfpago    INTEGER;
E_NUL  EXCEPTION;
BEGIN
	param_entrada:= 'descripcion: '||descripcion;

	--verificamos que los campos no nulos no sean nulos
	IF (descripcion IS NULL) THEN
		RAISE E_NUL;
	END IF;


	 
	INSERT INTO FORMAPAGO(descripcion,fechabaja) VALUES(descripcion,NULL) RETURNING idFormaPago INTO idfpago;
  INSERT INTO FORMAPAGOPARLAMENTARIO(idFormaPago) VALUES(idfpago);

   -- Fin de las operaciones
   rsp := 'OK';
 altalog ('altaFormaPagoParlamentario',param_entrada,rsp,rsp2);

   COMMIT;
EXCEPTION
   WHEN E_NUL
   THEN
      ROLLBACK;   
      rsp := 'ERROR: El campo descripcin es nulo, debe informarse';
    altalog ('altaFormaPagoParlamentario',param_entrada,rsp,rsp2);
   WHEN OTHERS
   THEN
      ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;
 altalog ('altaFormaPagoParlamentario',param_entrada,rsp,rsp2);
END ALTAFORMAPAGOPARLAMENTARIO;
/