create or replace
PROCEDURE ALTAGASTOPARLAMENTARIO 
(
  descripcion IN Gasto.descripcion%TYPE,  
  rsp OUT VARCHAR2  
) IS
/******************************************************************************
   NOMBRE:      altaGastoParlamentario
   PROPSITO:   gestiona el alta de un gasto Parlamentario

   PARAMETERS:  descripcion, rsp
   INPUT:       descripcion
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     altaGastoParlamentario('Dietas', rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
idGasto    INTEGER;
E_NUL  EXCEPTION;
rsp2 VARCHAR2(200);
BEGIN
	param_entrada:= 'descripcion: '||descripcion;

	--verificamos que los campos no nulos no sean nulos
	IF (descripcion IS NULL) THEN
		RAISE E_NUL;
	END IF;

	 
	INSERT INTO GASTO(descripcion,fechabaja) VALUES(descripcion,NULL)  RETURNING idCategoriaGasto INTO idGasto;
	INSERT INTO GASTOPARLAMENTARIO(idCategoriaGasto) VALUES(idGasto);

   -- Fin de las operaciones
   rsp := 'OK';
    altalog ('altaGastoParlamentario',param_entrada,rsp,rsp2);
   COMMIT;
EXCEPTION
   WHEN E_NUL
   THEN
      ROLLBACK;   
      rsp := 'ERROR: El campo descripcin es nulo, debe informarse';
altalog ('altaGastoParlamentario',param_entrada,rsp,rsp2);
   WHEN OTHERS
   THEN
      ROLLBACK;
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;
altalog ('altaGastoParlamentario',param_entrada,rsp,rsp2);
END ALTAGASTOPARLAMENTARIO;
/