create or replace
PROCEDURE ALTAIVA 
(
  DESCRIPCION IN IVA.descripcion%TYPE, 
  PORCENTAJE IN IVA.porcentaje%TYPE,
  RSP OUT VARCHAR2
)
IS
/******************************************************************************
   NOMBRE:      ALTAIVA
   PROPSITO:   gestiona el alta de un tipo de iva

   PARAMETERS:  descripcion, porcentaje, rsp
   INPUT:       descripcion, porcentaje
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     altaIva('Iva 21%', 21,rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
E_NUL  EXCEPTION;
E_NUL_PORCENTAJE  EXCEPTION;
rsp2 VARCHAR2(200);
BEGIN
	param_entrada:= 'descripcion: '||descripcion||
    'porcentaje: '||porcentaje;

	--verificamos que los campos no nulos no sean nulos
	IF (descripcion IS NULL) THEN
		RAISE E_NUL;
	END IF;
	IF (porcentaje IS NULL) THEN
		RAISE E_NUL_PORCENTAJE;
	END IF;
	 
	INSERT INTO IVA(descripcion,porcentaje,fechabaja) VALUES(descripcion,porcentaje,NULL);

   -- Fin de las operaciones
   rsp := 'OK';
altalog ('altaIva',param_entrada,rsp,rsp2);
   COMMIT;
EXCEPTION
   WHEN E_NUL
   THEN
      ROLLBACK;   
      rsp := 'ERROR: El campo descripcin es nulo, debe informarse';
altalog ('altaIva',param_entrada,rsp,rsp2);
   WHEN E_NUL_PORCENTAJE
   THEN
      ROLLBACK;   
      rsp := 'ERROR: El campo porcentaje es nulo, debe informarse';
altalog ('altaIva',param_entrada,rsp,rsp2);
   WHEN OTHERS
   THEN
      ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

altalog ('altaIva',param_entrada,rsp,rsp2);
END ALTAIVA;
/