create or replace
PROCEDURE ALTALOG (
   procedimiento_   IN LOGS.procedimiento%TYPE, 
   parentrada_      IN LOGS.parentrada%TYPE, 
   parsalida_       IN LOGS.parsalida%TYPE,
   rsp              OUT VARCHAR2
)
IS
/******************************************************************************
   NOMBRE:      altaLog
   PROPSITO:   gestiona el alta en la tabla log
                
   PARAMETERS:  procedimiento_, parentrada_, parsalida_,rsp
   INPUT:       procedimiento_, parentrada_, parsalida_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa, 'ERROR: Tipo de Error' en
                caso contrario
   EJEMPLO DE USO:     altaLog('altaEstado', 'descripcion:Francia','ok', rst)
******************************************************************************/
  
   E_NUL             EXCEPTION;
BEGIN
 

   --verificamos que los campos no nulos no sean nulos
   IF ((procedimiento_ IS NULL) OR (parentrada_ IS NULL) OR (parsalida_ IS NULL) ) THEN 
        RAISE E_NUL;
   END IF; 

   -- insertamos el nuevo log
   INSERT INTO LOGS(FECHA, PROCEDIMIENTO, PARENTRADA, PARSALIDA) 
          VALUES (SYSDATE, procedimiento_, parentrada_, parsalida_);
   
   -- Fin de las operaciones
   rsp := 'OK';
   COMMIT;
EXCEPTION
 WHEN E_NUL
   THEN
      rsp := 'ERROR: Hay un campo nulo al acceder a log, debe informarse';
WHEN OTHERS
   THEN
      rsp :=    'ERROR:'||SUBSTR (SQLERRM, 1, 100);
END altaLog;
/