create or replace
PROCEDURE ALTAPAIS 
(
  DESCRIPCION IN ESTADOPAIS.descripcion%TYPE,  
  RSP OUT VARCHAR2  
) IS 
/******************************************************************************
   NOMBRE:      altaPais
   PROPSITO:   gestiona el alta de un pais

   PARAMETERS:  descripcion, rsp
   INPUT:       descripcion
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     altaPais('Luxemburgo', rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
idEstadoPais    INTEGER;
E_NUL  EXCEPTION;
rsp2 VARCHAR2(200);
BEGIN
	param_entrada:= 'descripcion: '||descripcion;

	--verificamos que los campos no nulos no sean nulos
	IF (descripcion IS NULL) THEN
		RAISE E_NUL;
	END IF;

	 
	INSERT INTO ESTADOPAIS(descripcion,FECHABAJA) VALUES(descripcion,NULL)  RETURNING idEstadoPais INTO idEstadoPais;
	INSERT INTO PAIS(idEstadoPais) VALUES(idEstadoPais);

   -- Fin de las operaciones
   rsp := 'OK';
altalog ('altaPais',param_entrada,rsp,rsp2);
   COMMIT;
EXCEPTION
   WHEN E_NUL
   THEN
      ROLLBACK;   
      rsp := 'ERROR: El campo descripcin es nulo, debe informarse';
altalog ('altaPais',param_entrada,rsp,rsp2);
   WHEN OTHERS
   THEN
      ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;
altalog ('altaPais',param_entrada,rsp,rsp2);
END ALTAPAIS;
/