create or replace
PROCEDURE BAJEST1
(
  idParlamento_ IN EST1.idParlamento%TYPE,
  RSP OUT VARCHAR2
)
IS
/******************************************************************************
   NOMBRE:      BAJEST1
   PROPSITO:   gestiona la eliminacion de un registro en la tabla EST1

   PARAMETERS:  idParlamento_, rsp
   INPUT:       idParlamento_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     bajEST1('1',rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
contador      INTEGER;
E_PARLAMENTO_NUL  EXCEPTION;
E_INEX_PARLAMENTO EXCEPTION;
rsp2 VARCHAR2(200);
BEGIN
	param_entrada:= 'idParlamento_: '||idparlamento_;

	--verificamos que los campos no nulos no sean nulos
	IF (idparlamento_ IS NULL) THEN
		RAISE E_PARLAMENTO_NUL;
	END IF;
	 
--Busco en la tabla de EST1 si ya existe el registro
    SELECT COUNT(*) INTO contador 
    FROM EST1
    WHERE IDPARLAMENTO=idparlamento_;
    
    IF (contador=0) THEN
      RAISE E_INEX_PARLAMENTO;
    END IF;
    
	DELETE EST1  
  WHERE idparlamento=idparlamento_;

   -- Fin de las operaciones
   rsp := 'OK';
altalog ('bajEST1',param_entrada,rsp,rsp2);
   COMMIT;
EXCEPTION
 WHEN E_INEX_PARLAMENTO
   THEN
      ROLLBACK;   
      rsp :='ERROR: No existe ningun registro';
      altalog ('bajEST1',param_entrada,rsp,rsp2);
   WHEN E_PARLAMENTO_NUL
   THEN
      ROLLBACK;   
      rsp := 'ERROR: El campo idparlamento es nulo, debe informarse';
      altalog ('bajEST1',param_entrada,rsp,rsp2);      
   WHEN OTHERS
   THEN
      ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

altalog ('bajEST1',param_entrada,rsp,rsp2);
END BAJEST1;
/