create or replace
PROCEDURE BAJEST4
(
  idparlamentario_ IN EST4.idparlamentario%TYPE, 
  idparlamento_ IN EST4.idparlamento%TYPE, 
  RSP OUT VARCHAR2
)
IS

/******************************************************************************
   NOMBRE:      bajEST4
   PROPSITO:   gestiona la baja de un registro en la tabla EST4

   PARAMETERS:  idparlamentario_,idparlamento_, rsp
   INPUT:       idparlamentario_,idparlamento_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     bajEST4('1','1',rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
E_PARLAMENTARIO_NUL  EXCEPTION;
contador      INTEGER;
E_INEX_REG EXCEPTION;
rsp2 VARCHAR2(200);
BEGIN
	param_entrada:= ' idparlamentario_:'||idparlamentario_||' idparlamento_:'||idparlamento_;

		IF (idparlamentario_ IS NULL or idparlamento_ IS NULL) THEN
		RAISE E_PARLAMENTARIO_NUL;
	END IF;	 
--Busco en la tabla de EST4 si existe un registro igual
    SELECT COUNT(*) INTO contador 
    FROM EST4
    WHERE idparlamentario=idparlamentario_
    AND idparlamento = idparlamento_;
    
    IF (contador=0) THEN
      RAISE E_INEX_REG;
    END IF;  
    
    DELETE EST4
    WHERE idparlamentario=idparlamentario_
    AND idparlamento = idparlamento_;
    

   -- Fin de las operaciones
   rsp := 'OK';
    altalog ('bajEST4',param_entrada,rsp,rsp2);
   COMMIT;
EXCEPTION
 WHEN E_INEX_REG
   THEN
      ROLLBACK;   
      rsp :='ERROR: No existe el registro';
      altalog ('bajEST4',param_entrada,rsp,rsp2);
   WHEN E_PARLAMENTARIO_NUL
   THEN
      ROLLBACK;   
      rsp := 'ERROR: El campo parlamentario es nulo, debe informarse';
      altalog ('bajEST4',param_entrada,rsp,rsp2);                
   WHEN OTHERS
   THEN
      ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

altalog ('bajEST4',param_entrada,rsp,rsp2);

END BAJEST4;
/