create or replace
PROCEDURE BAJEST6
(
  anyo_ IN EST6.anyo%TYPE, 
  RSP OUT VARCHAR2
)
IS

/******************************************************************************
   NOMBRE:      bajEST6
   PROPSITO:   gestiona la baja de un registro en la tabla EST6

   PARAMETERS:  anyo_, rsp
   INPUT:       anyo_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     bajEST6('2013',rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
E_ANYO_NUL  EXCEPTION;
contador      INTEGER;
E_INEX_REG EXCEPTION;
rsp2 VARCHAR2(200);
BEGIN
	param_entrada:= ' anyo_:'||anyo_;

		IF (anyo_ IS NULL) THEN
		RAISE E_ANYO_NUL;
	END IF;	 
--Busco en la tabla de EST6 si existe un registro igual
    SELECT COUNT(*) INTO contador 
    FROM EST6
    WHERE ANYO=anyo_;
    
    IF (contador=0) THEN
      RAISE E_INEX_REG;
    END IF;  
    
    DELETE EST6
    WHERE anyo=anyo_;
    

   -- Fin de las operaciones
   rsp := 'OK';
    altalog ('bajEST6',param_entrada,rsp,rsp2);
   COMMIT;
EXCEPTION
 WHEN E_INEX_REG
   THEN
      ROLLBACK;   
      rsp :='ERROR: No existe el registro';
      altalog ('bajEST6',param_entrada,rsp,rsp2);
   WHEN E_ANYO_NUL
   THEN
      ROLLBACK;   
      rsp := 'ERROR: El campo anyo es nulo, debe informarse';
      altalog ('bajEST6',param_entrada,rsp,rsp2);                
   WHEN OTHERS
   THEN
      ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

altalog ('bajEST6',param_entrada,rsp,rsp2);
END BAJEST6;
/