create or replace
PROCEDURE bajEstadoGasto (   
   idEstadoGasto_     IN    EstadoGasto.idEstadoGasto%TYPE,
   rsp              OUT   VARCHAR2
)
IS
/******************************************************************************
   NOMBRE:      bajEstadoGasto
   PROPSITO:   gestiona la baja de un Estado de gasto

   PARAMETERS:  idEstadoGasto_, rsp
   INPUT:       idEstadoGasto_,
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     bajEstadoGasto('1',rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
contador      INTEGER;
E_ESTADO_NUL  EXCEPTION;
E_ESTADO   EXCEPTION;
rsp2 VARCHAR2(200);
BEGIN
	param_entrada:= 'idEstadoGasto:'||idEstadoGasto_;

	--verificamos que los campos no nulos no sean nulos
	IF (idEstadoGasto_ IS NULL) THEN
		RAISE E_ESTADO_NUL;
	END IF;
  
  --busco si existe
  SELECT COUNT(*) INTO contador 
    FROM ESTADOGASTO 
    WHERE IDESTADOGASTO=idEstadoGasto_;
    
    IF (contador=0) THEN
      RAISE E_ESTADO;
    END IF;
    
     

 --Modificamos la fecha de baja del estado gasto
	UPDATE ESTADOGASTO
  SET FECHABAJA=SYSDATE
  WHERE IDESTADOGASTO=idEstadoGasto_;  
  
  
   -- Fin de las operaciones
   rsp := 'OK';
  altalog ('bajEstadoGasto',param_entrada,rsp,rsp2);
   COMMIT;
EXCEPTION
   WHEN E_ESTADO_NUL
   THEN
      ROLLBACK;   
      rsp := 'ERROR: El campo idestadogasto es nulo, debe informarse';
  altalog ('bajEstadoGasto',param_entrada,rsp,rsp2);
   
   WHEN E_ESTADO
   THEN
      ROLLBACK;   
      rsp := 'ERROR: No se encuentra un registro de estado de gasto con este identificador';
  altalog ('bajEstadoGasto',param_entrada,rsp,rsp2);
   WHEN OTHERS
   THEN
      ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;
  altalog ('bajEstadoGasto',param_entrada,rsp,rsp2);
END bajEstadoGasto;
/