create or replace
PROCEDURE BAJGASTOPARLAMENTO
(
  idcategoriagasto_ IN Gasto.idcategoriagasto%TYPE,  
  rsp OUT VARCHAR2  
) IS
/******************************************************************************
   NOMBRE:      bajGastoParlamento
   PROPSITO:   gestiona la baja de un gasto de un Parlamento

   PARAMETERS:  idcategoriagasto_, rsp
   INPUT:       idcategoriagasto_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     bajGastoParlamento('1', rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
idGasto    INTEGER;
contador      INTEGER;
E_NUL  EXCEPTION;
E_GASTO EXCEPTION;
rsp2 VARCHAR2(200);

BEGIN
	param_entrada:= 'idcategoriagasto: '||idcategoriagasto_;

	--verificamos que los campos no nulos no sean nulos
	IF (idcategoriagasto_ IS NULL) THEN
		RAISE E_NUL;
	END IF;
  
    --busco si existe
  SELECT COUNT(*) INTO contador 
    FROM gastoparlamento 
    WHERE IDCATEGORIAGASTO=idcategoriagasto_;
    
    IF (contador=0) THEN
      RAISE E_GASTO;
    END IF;
    

	--Modificamos la fecha de baja de la categoria de gasto
	UPDATE GASTO
  SET FECHABAJA=SYSDATE
  WHERE idCategoriaGasto=idcategoriagasto_;  


   -- Fin de las operaciones
   rsp := 'OK';
  altalog ('bajGastoParlamento',param_entrada,rsp,rsp2);
   COMMIT;
EXCEPTION

   WHEN E_GASTO
   THEN
      ROLLBACK;   
      rsp := 'ERROR: No existe esta categoria de gasto';
  altalog ('bajGastoParlamento',param_entrada,rsp,rsp2);
   WHEN E_NUL
   THEN
      ROLLBACK;   
      rsp := 'ERROR: El campo idcategoriagasto es nulo, debe informarse';
  altalog ('bajGastoParlamento',param_entrada,rsp,rsp2);

   WHEN OTHERS
   THEN
      ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

  altalog ('bajGastoParlamento',param_entrada,rsp,rsp2);

END BAJGASTOPARLAMENTO;
/