create or replace
PROCEDURE BAJPARLAMENTARIO
(
  idparlamento_ IN PARLAMENTARIO.idparlamento%TYPE,  
  idparlamentario_ IN PARLAMENTARIO.idparlamentario%TYPE,  
  RSP OUT VARCHAR2  
) IS 
/******************************************************************************
   NOMBRE:      bajparlamentario
   PROPSITO:   gestiona la baja de un parlamentario

   PARAMETERS:  idparlamento_,idparlamentario_, rsp
   INPUT:       idparlamento_,idparlamentario_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     bajparlamentario('1','3', rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
contador      INTEGER;
E_NUL  EXCEPTION;
E_EXISTE_PARLA  EXCEPTION;
rsp2 VARCHAR2(200);
BEGIN
	param_entrada:= 'idparlamentario: '||idparlamentario_||'idparlamento: '||idparlamento_;

	--verificamos que los campos no nulos no sean nulos
	IF ((idparlamentario_ IS NULL) OR (idparlamento_ IS NULL)) THEN
		RAISE E_NUL;
	END IF;
      
  
    
 --buscamos si existe el parlamentario
   SELECT COUNT(*) INTO contador 
    FROM PARLAMENTARIO
    WHERE IDPARLAMENTARIO=idparlamentario_
    AND IDPARLAMENTO=idparlamento_
     AND FECHABAJA IS NULL;
    
    IF(contador=0) THEN
      RAISE E_EXISTE_PARLA;
    END IF;    
  
  --Modificamos la fecha de baja del parlamentario
	UPDATE PARLAMENTARIO
  SET FECHABAJA=SYSDATE
  WHERE IDPARLAMENTARIO=idparlamentario_
  AND IDPARLAMENTO=idparlamento_;


  SELECT COUNT (*) INTO contador
  FROM PARLAMENTARIO
  WHERE IDPARLAMENTO=idparlamento_
   AND FECHABAJA IS NULL;
  
  
  UPDATE PARLAMENTO
  SET NUMEROPARLAMENTARIOS=contador
  WHERE IDPARLAMENTO=idparlamento_;
   -- Fin de las operaciones
   rsp := 'OK';
  altalog ('bajParlamentario',param_entrada,rsp,rsp2);
   COMMIT;
EXCEPTION
   WHEN E_NUL
   THEN
      ROLLBACK;      
      rsp := 'ERROR: El campo idparlamentario es nulo o el idparlamento es nulo, debe informarse';
  altalog ('bajParlamentario',param_entrada,rsp,rsp2);
   WHEN E_EXISTE_PARLA
   THEN
      ROLLBACK;      
      rsp := 'ERROR: No existe el parlamentario';
  altalog ('bajParlamentario',param_entrada,rsp,rsp2);
   WHEN OTHERS
   THEN
      ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;
  altalog ('bajParlamentario',param_entrada,rsp,rsp2);   
   END BAJPARLAMENTARIO;
/