create or replace
PROCEDURE MODEST1
(
  idParlamento_ IN EST1.idParlamento%TYPE, 
  nombre_ IN EST1.nombre%TYPE,
  totalGasto_ IN EST1.totalGasto%TYPE,
  RSP OUT VARCHAR2
)
IS
/******************************************************************************
   NOMBRE:      MODEST1
   PROPSITO:   gestiona la modificacin de un registro en la tabla EST1

   PARAMETERS:  idParlamento_, nombre_,totalGasto_, rsp
   INPUT:       idParlamento_, nombre_,totalGasto_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     modEST1('1','Parlament Catalan','1500',rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
contador      INTEGER;
E_PARLAMENTO_NUL  EXCEPTION;
E_NOMBRE_NUL  EXCEPTION;
E_GASTO_NUL  EXCEPTION;
E_INEX_PARLAMENTO EXCEPTION;
rsp2 VARCHAR2(200);
BEGIN
	param_entrada:= 'idParlamento_: '||idparlamento_||' nombre_: '||nombre_||
    'totalGasto_: '||totalGasto_;

	--verificamos que los campos no nulos no sean nulos
	IF (idparlamento_ IS NULL) THEN
		RAISE E_PARLAMENTO_NUL;
	END IF;
	IF (nombre_ IS NULL) THEN
		RAISE E_NOMBRE_NUL;
	END IF;  
	IF (totalGasto_ IS NULL) THEN
		RAISE E_GASTO_NUL;
	END IF;
	 
--Busco en la tabla de EST1 si ya existe el registro
    SELECT COUNT(*) INTO contador 
    FROM EST1
    WHERE IDPARLAMENTO=idparlamento_;
    
    IF (contador=0) THEN
      RAISE E_INEX_PARLAMENTO;
    END IF;
    
	UPDATE EST1
  SET totalgasto=totalGasto_,
  nombre=nombre_
  WHERE idparlamento=idparlamento_;

   -- Fin de las operaciones
   rsp := 'OK';
altalog ('modEST1',param_entrada,rsp,rsp2);
   COMMIT;
EXCEPTION
 WHEN E_INEX_PARLAMENTO
   THEN
   ROLLBACK;   
      rsp :='ERROR: No existe ningun registro';
      altalog ('modEST1',param_entrada,rsp,rsp2);   
   WHEN E_PARLAMENTO_NUL
   THEN
   ROLLBACK;   
      rsp := 'ERROR: El campo idparlamento es nulo, debe informarse';
      altalog ('modEST1',param_entrada,rsp,rsp2);      
   WHEN E_NOMBRE_NUL
   THEN
   ROLLBACK;   
      rsp := 'ERROR: El campo nombre es nulo, debe informarse';
      altalog ('modEST1',param_entrada,rsp,rsp2);   
   WHEN E_GASTO_NUL
   THEN
   ROLLBACK;   
      rsp := 'ERROR: El campo gasto es nulo, debe informarse';
      altalog ('modEST1',param_entrada,rsp,rsp2);      

   WHEN OTHERS
   THEN
   ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

altalog ('modEST1',param_entrada,rsp,rsp2);

END MODEST1;
/