create or replace
PROCEDURE MODEST8
(
  anyo_ IN EST8.anyo%TYPE, 
  total_ IN EST8.total%TYPE,
  RSP OUT VARCHAR2
)
IS

/******************************************************************************
   NOMBRE:      modEST8
   PROPSITO:   gestiona el alta de un nuevo registro en la tabla EST8

   PARAMETERS:  anyo_,total_, rsp
   INPUT:       anyo_,total_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     modEST8('2012','450000',rsp)
   NOTAS: -
******************************************************************************/
param_entrada	  VARCHAR2(500);
err_msg        	VARCHAR2 (100);
E_TOTAL_NUL  EXCEPTION;
E_ANYO_NUL  EXCEPTION;
contador      INTEGER;
E_INEX_PARLAMENTO EXCEPTION;
rsp2 VARCHAR2(200);
BEGIN
	param_entrada:= 'anyo_: '||anyo_||' total_: '||total_;

	--verificamos que los campos no nulos no sean nulos
	IF (anyo_ IS NULL) THEN
		RAISE E_ANYO_NUL;
	END IF;
	IF (total_ IS NULL) THEN
		RAISE E_TOTAL_NUL;
	END IF;  
  
--Busco en la tabla de EST8 si existe un registro igual
    SELECT COUNT(*) INTO contador 
    FROM EST8
    WHERE ANYO=anyo_;
    
    IF (contador=0) THEN
      RAISE E_INEX_PARLAMENTO;
    END IF;  
      

	UPDATE EST8
  SET total=total_
  WHERE anyo=anyo_;

   -- Fin de las operaciones
   rsp := 'OK';
altalog ('modEST8',param_entrada,rsp,rsp2);
   COMMIT;
EXCEPTION
WHEN E_INEX_PARLAMENTO
   THEN
   ROLLBACK;   
      rsp :='ERROR: No existe el registro';
      altalog ('modEST8',param_entrada,rsp,rsp2);

   WHEN E_ANYO_NUL
   THEN
   ROLLBACK;   
      rsp := 'ERROR: El campo anyo es nulo, debe informarse';
      altalog ('modEST8',param_entrada,rsp,rsp2);      

   WHEN E_TOTAL_NUL
   THEN
   ROLLBACK;   
      rsp := 'ERROR: El campo promedio es nulo, debe informarse';
      altalog ('modEST8',param_entrada,rsp,rsp2);   
   WHEN OTHERS
   THEN
   ROLLBACK;   
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;

altalog ('modEST8',param_entrada,rsp,rsp2);
END MODEST8;
/