create or replace
FUNCTION CONSULTA_R6f (
  anyo_           IN  INTEGER
)
            RETURN TA_R6f
    IS
  
/******************************************************************************
   Nombre:                 CONSULTA_R6f
   Objetivo:           Dado un ao: el listado de todos los parlamentos com su estado contable, incluyendo:
                      Nombre del parlamento
                      Nmero de parlamentarios
                      Suma de todos los gastos pendientes de aprovacin
                      Suma de todos los gastos aprovadas
                      Suma de todos los gastos pendientes de abono
                      Suma de todos los gastos abonadas

   PARAMETERS:  anyo_,rsp
   INPUT:       anyo_
   OUTPUT:      rsp
   RETORNA:     'OK' si la operacin ha sido exitosa
                'ERROR: Tipo de Error' en caso contrario
   EJEMPLO DE USO:     CONSULTA_R6f('2012')
******************************************************************************/
      l_rc sys_refcursor;
      param_entrada	  VARCHAR2(500);
      err_msg        	VARCHAR2 (100);
      E_FECHA_NUL EXCEPTION;
	  resultado       TA_R6f:=TA_R6f();
	  nombre_		VARCHAR(200);
	  num_			NUMBER;
	  pend_			NUMBER(10,2);
	  apro_			NUMBER(10,2);
	  pabon_		NUMBER(10,2);
	  abon_			NUMBER(10,2);
	  i             INTEGER:=1;
	  rsp	VARCHAR(200);
    rsp2 VARCHAR2(200);    

    BEGIN
      param_entrada:= ' anyo: '||anyo_;

--verificamos que los campos no nulos no sean nulos
  IF (anyo_ IS NULL) THEN
		RAISE E_FECHA_NUL;
  END IF;
      --Asumo que el codigo 1 de los estados es pendientes de aprobacion
      --el 2 aprobadas,el 3 pendientes de abono y el 4 abonadas

      OPEN l_rc FOR
       SELECT PARL.NOMBRE, PARL.NUMEROPARLAMENTARIOS,
        NVL(CONSULTA_AUX_TOTAL_G_ESTADO(PARL.IDPARLAMENTO,anyo_,'1'),0) AS PENDIENTES_APROBACION,
        NVL(CONSULTA_AUX_TOTAL_G_ESTADO(PARL.IDPARLAMENTO,anyo_,'2'),0) AS APROBADAS,
        NVL(CONSULTA_AUX_TOTAL_G_ESTADO(PARL.IDPARLAMENTO,anyo_,'3'),0) AS PENDIENTES_ABONO,
        NVL(CONSULTA_AUX_TOTAL_G_ESTADO(PARL.IDPARLAMENTO,anyo_,'4'),0) AS ABONADAS
        FROM PARLAMENTO PARL;

	 LOOP

     FETCH l_rc INTO nombre_, num_, pend_, apro_,pabon_,abon_  ;
     EXIT WHEN l_rc%NOTFOUND;
       resultado.extend;
       resultado(i):= TY_R6f(nombre_, num_, pend_, apro_,pabon_,abon_);
       i:= i+1;
	 END LOOP;
	 CLOSE l_rc;
  rsp:='OK';
      altalog ('CONSULTA_R6f',param_entrada,rsp,rsp2);                              
	 RETURN resultado;

EXCEPTION
   WHEN E_FECHA_NUL
   THEN
      rsp :='ERROR: El campo ao es nulo, debe informarse';
      altalog ('CONSULTA_R6f',param_entrada,rsp,rsp2);                                    
       return null;
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;
      altalog ('CONSULTA_R6f',param_entrada,rsp,rsp2);                                           
      return null;
   END;
/