create or replace
FUNCTION CONSULTA_AUX_TOT_PARLAMENTO (
  idparlamento_   IN  HISTORICOGASTOPARLAMENTO.idparlamento%TYPE,
  anyo_           IN  INTEGER
)
      RETURN NUMBER
    IS
/******************************************************************************
   Nombre:            CONSULTA_AUX_TOT_PARLAMENTO
   Objetivo:          Dado un parlamento, un ao
                      Retorna el importe total de gastos durante el ao para el parlamento indicado de la tabla
                      de gastos de parlamento

                   
   PARAMETERS:  idparlamento_,anyo_
   INPUT:       idparlamento_,anyo_
   RETORNA:     El resultado
   EJEMPLO DE USO:     CONSULTA_AUX_TOT_PARLAMENTO('1','2012')
******************************************************************************/    
      res NUMBER(10,2);
      param_entrada	  VARCHAR2(500);
      err_msg        	VARCHAR2 (100);  
      E_PARLAMENTO_NUL  EXCEPTION;
      E_FECHA_NUL EXCEPTION;
    rsp2 VARCHAR2(200);          
    rsp VARCHAR2(200);
    BEGIN
      param_entrada:= ' idparlamento: '||idparlamento_||' anyo: '||anyo_;
    
--verificamos que los campos no nulos no sean nulos
  IF (anyo_ IS NULL) THEN
		RAISE E_FECHA_NUL;  
  END IF;
  IF (idparlamento_ IS NULL) THEN
		RAISE E_PARLAMENTO_NUL;  
  END IF;

          SELECT NVL(SUM(hg.importesiniva),0) AS TOTAL INTO res
          FROM HISTORICOGASTOPARLAMENTO HG
          WHERE IDPARLAMENTO=idparlamento_
          AND TO_CHAR(FECHA,'YYYY')=anyo_;

        rsp := 'OK';
    altalog ('CONSULTA_AUX_TOT_PARLAMENTO',param_entrada,rsp,rsp2);                
     RETURN res;
EXCEPTION
   WHEN E_PARLAMENTO_NUL
   THEN
      rsp :='ERROR: El campo parlamento es nulo, debe informarse';
    altalog ('CONSULTA_AUX_TOT_PARLAMENTO',param_entrada,rsp,rsp2);                      
       return null;
   WHEN E_FECHA_NUL
   THEN
      rsp :='ERROR: El campo ao es nulo, debe informarse';             
    altalog ('CONSULTA_AUX_TOT_PARLAMENTO',param_entrada,rsp,rsp2);                      
       return null;
   WHEN OTHERS
   THEN
      err_msg := SUBSTR (SQLERRM, 1, 100);
      rsp :=    'ERROR:'
             || err_msg;
    altalog ('CONSULTA_AUX_TOT_PARLAMENTO',param_entrada,rsp,rsp2);                             
      return null;
   END;
/